Index: /pjproject/main/pjsip/build/pjsip_core.dsp
===================================================================
--- /pjproject/main/pjsip/build/pjsip_core.dsp	(revision 42)
+++ /pjproject/main/pjsip/build/pjsip_core.dsp	(revision 43)
@@ -33,14 +33,14 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 0
-# PROP BASE Output_Dir "Release"
-# PROP BASE Intermediate_Dir "Release"
+# PROP BASE Output_Dir ".\output\pjsip-core-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir ".\output\pjsip-core-i386-win32-vc6-release"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 0
-# PROP Output_Dir ".\output\pjsip_core_vc6_Release"
-# PROP Intermediate_Dir ".\output\pjsip_core_vc6_Release"
+# PROP Output_Dir ".\output\pjsip-core-i386-win32-vc6-release"
+# PROP Intermediate_Dir ".\output\pjsip-core-i386-win32-vc6-release"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /MD /W4 /Zi /O2 /I "../src" /I "../../pjlib/src" /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /FR /FD /c
+# ADD CPP /nologo /MD /W4 /Zi /O2 /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
@@ -51,5 +51,5 @@
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 /nologo /out:"../lib/pjsip_core_vc6s.lib"
+# ADD LIB32 /nologo /out:"../lib/pjsip-core-i386-win32-vc6-release.lib"
 
 !ELSEIF  "$(CFG)" == "pjsip_core - Win32 Debug"
@@ -57,14 +57,14 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 1
-# PROP BASE Output_Dir "Debug"
-# PROP BASE Intermediate_Dir "Debug"
+# PROP BASE Output_Dir ".\output\pjsip-core-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir ".\output\pjsip-core-i386-win32-vc6-debug"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 1
-# PROP Output_Dir ".\output\pjsip_core_vc6_Debug"
-# PROP Intermediate_Dir ".\output\pjsip_core_vc6_Debug"
+# PROP Output_Dir ".\output\pjsip-core-i386-win32-vc6-debug"
+# PROP Intermediate_Dir ".\output\pjsip-core-i386-win32-vc6-debug"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../src" /I "../../pjlib/src" /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /FR /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
@@ -75,5 +75,5 @@
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 /nologo /out:"../lib/pjsip_core_vc6sd.lib"
+# ADD LIB32 /nologo /out:"../lib/pjsip-core-i386-win32-vc6-debug.lib"
 
 !ENDIF 
@@ -136,73 +136,77 @@
 # Begin Source File
 
-SOURCE=..\src\pjsip_core.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\print.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_auth.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_auth_msg.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_auth_parser.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_config.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_endpoint.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_event.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_misc.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_module.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_msg.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_parser.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_private.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_resolve.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transaction.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_types.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_uri.h
+SOURCE=..\include\pjsip_core.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\print_util.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_auth.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_auth_msg.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_auth_parser.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_config.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_endpoint.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_errno.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_event.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_misc.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_module.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_msg.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_parser.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_private.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_resolve.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transaction.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_types.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_uri.h
 # End Source File
 # End Group
@@ -212,5 +216,5 @@
 # Begin Source File
 
-SOURCE=..\src\pjsip\sip_msg_i.h
+SOURCE=..\include\pjsip\sip_msg_i.h
 # End Source File
 # End Group
Index: /pjproject/main/pjsip/build/pjsip_ua.dsp
===================================================================
--- /pjproject/main/pjsip/build/pjsip_ua.dsp	(revision 42)
+++ /pjproject/main/pjsip/build/pjsip_ua.dsp	(revision 43)
@@ -88,13 +88,17 @@
 # Begin Source File
 
-SOURCE=..\src\pjsip_mod_ua\sip_dialog.c
+SOURCE="..\src\pjsip-ua\sip_dialog.c"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_mod_ua\sip_reg.c
+SOURCE="..\src\pjsip-ua\sip_reg.c"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_mod_ua\sip_ua.c
+SOURCE="..\src\pjsip-ua\sip_ua.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjsip-ua\sip_ua_private.h"
 # End Source File
 # End Group
Index: /pjproject/main/pjsip/include/pjsip/print_util.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/print_util.h	(revision 43)
+++ /pjproject/main/pjsip/include/pjsip/print_util.h	(revision 43)
@@ -0,0 +1,99 @@
+/* $Id$
+ */
+#ifndef __PJSIP_PRINT_H__
+#define __PJSIP_PRINT_H__
+
+#define copy_advance_check(buf,str)   \
+	do { \
+	    if ((str).slen+10 >= (endbuf-buf)) return -1;	\
+	    pj_memcpy(buf, (str).ptr, (str).slen); \
+	    buf += (str).slen; \
+	} while (0)
+
+/*
+static char *imp_copy_advance_pair(char *buf, char *endbuf, const char *str1, int len1, const pj_str_t *str2)
+{
+    if (str2->slen) {
+	int printed = len1+str2->slen;
+	if (printed+10 >= (endbuf-buf)) return NULL;
+	pj_memcpy(buf,str1,len1);
+	pj_memcpy(buf+len1, str2->ptr, str2->slen);
+	return buf + printed;
+    } else
+	return buf;
+}
+*/
+
+#define copy_advance_pair_check(buf,str1,len1,str2)   \
+	do { \
+	    if (str2.slen) { \
+		printed = len1+str2.slen; \
+		if (printed+10 >= (endbuf-buf)) return -1;	\
+		pj_memcpy(buf,str1,len1); \
+		pj_memcpy(buf+len1, str2.ptr, str2.slen); \
+		buf += printed; \
+	    } \
+	} while (0)
+/*
+#define copy_advance_pair(buf,str1,len1,str2)   \
+	do { \
+	    buf = imp_copy_advance_pair(buf, endbuf, str1, len1, &str2); \
+	    if (buf == NULL) return -1; \
+	} while (0)
+*/
+
+#define copy_advance_pair_quote_check(buf,str1,len1,str2,quotebegin,quoteend) \
+	do { \
+	    if (str2.slen) { \
+		printed = len1+str2.slen+2; \
+		if (printed+10 >= (endbuf-buf)) return -1;	\
+		pj_memcpy(buf,str1,len1); \
+		*(buf+len1)=quotebegin; \
+		pj_memcpy(buf+len1+1, str2.ptr, str2.slen); \
+		*(buf+printed-1) = quoteend; \
+		buf += printed; \
+	    } \
+	} while (0)
+
+#define copy_advance_no_check(buf,str)   \
+	pj_memcpy(buf, (str).ptr, (str).slen); \
+	buf += (str).slen;
+
+#define copy_advance_pair_no_check(buf,str1,len1,str2)   \
+	if (str2.slen) { \
+	    pj_memcpy(buf,str1,len1); \
+	    pj_memcpy(buf+len1, str2.ptr, str2.slen); \
+	    buf += len1+str2.slen; \
+	}
+
+#define copy_advance 		copy_advance_check
+#define copy_advance_pair 	copy_advance_pair_check
+#define copy_advance_pair_quote	copy_advance_pair_quote_check
+
+#define copy_advance_pair_quote_cond(buf,str1,len1,str2,quotebegin,quoteend) \
+	do {	\
+	    if (str2.slen && *str2.ptr!=quotebegin) \
+		copy_advance_pair_quote(buf,str1,len1,str2,quotebegin,quoteend); \
+	    else \
+		copy_advance_pair(buf,str1,len1,str2); \
+	} while (0)
+
+/*
+ * Internal type declarations.
+ */
+typedef void* (*pjsip_hdr_clone_fptr)(pj_pool_t *, const void*);
+typedef int   (*pjsip_hdr_print_fptr)(void *hdr, char *buf, pj_size_t len);
+
+extern const pj_str_t pjsip_hdr_names[];
+
+PJ_INLINE(void) init_hdr(void *hptr, pjsip_hdr_e htype, void *vptr)
+{
+    pjsip_hdr *hdr = hptr;
+    hdr->type = htype;
+    hdr->name = hdr->sname = pjsip_hdr_names[htype];
+    hdr->vptr = vptr;
+    pj_list_init(hdr);
+}
+
+#endif	/* __PJSIP_PRINT_H__ */
+
Index: /pjproject/main/pjsip/include/pjsip/sip_auth.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_auth.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_auth.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_AUTH_SIP_AUTH_H__
@@ -61,5 +60,5 @@
 typedef struct pjsip_cached_auth_hdr
 {
-    PJ_DECL_LIST_MEMBER(struct pjsip_cached_auth_hdr)
+    PJ_DECL_LIST_MEMBER(struct pjsip_cached_auth_hdr);
 
     pjsip_method	     method;
@@ -81,5 +80,5 @@
 typedef struct pjsip_auth_session
 {
-    PJ_DECL_LIST_MEMBER(struct pjsip_auth_session)
+    PJ_DECL_LIST_MEMBER(struct pjsip_auth_session);
 
     pj_str_t			 realm;
Index: /pjproject/main/pjsip/include/pjsip/sip_auth_msg.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_auth_msg.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_auth_msg.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_AUTH_SIP_AUTH_MSG_H__
@@ -69,5 +68,5 @@
 struct pjsip_authorization_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_authorization_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_authorization_hdr);
     pj_str_t scheme;
     union
@@ -158,5 +157,5 @@
 struct pjsip_www_authenticate_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_www_authenticate_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_www_authenticate_hdr);
     pj_str_t	scheme;
     union
Index: /pjproject/main/pjsip/include/pjsip/sip_auth_parser.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_auth_parser.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_auth_parser.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_AUTH_SIP_AUTH_PARSER_H__
@@ -25,6 +24,8 @@
  * such as Authorization, WWW-Authenticate, Proxy-Authorizization, and 
  * Proxy-Authenticate headers.
+ *
+ * @return      PJ_SUCCESS or the appropriate status code.
  */
-PJ_DECL(void) pjsip_auth_init_parser();
+PJ_DECL(pj_status_t) pjsip_auth_init_parser(void);
 
 /**
Index: /pjproject/main/pjsip/include/pjsip/sip_config.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_config.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_config.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_CONFIG_H__
@@ -134,5 +133,4 @@
 
 #include <pj/config.h>
-#include <pj/compat.h>
 
 
Index: /pjproject/main/pjsip/include/pjsip/sip_endpoint.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_endpoint.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_endpoint.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_ENDPOINT_H__
@@ -29,5 +28,6 @@
  * all SIP objects in an application. It performs the following roles:
  *  - it manages the allocation/deallocation of memory pools for all objects.
- *  - it manages listeners and transports, and how they are used by transactions.
+ *  - it manages listeners and transports, and how they are used by 
+ *    transactions.
  *  - it owns transaction hash table.
  *  - it receives incoming messages from transport layer and automatically
@@ -35,5 +35,6 @@
  *  - it has a single instance of timer management (timer heap).
  *  - it manages modules, which is the primary means of extending the library.
- *  - it provides single polling function for all objects and distributes events.
+ *  - it provides single polling function for all objects and distributes 
+ *    events.
  *  - it provides SIP policy such as which outbound proxy to use for all
  *    outgoing SIP request messages.
@@ -50,12 +51,19 @@
 /**
  * Create an instance of SIP endpoint from the specified pool factory.
- * The pool factory reference then will be kept by the endpoint, so that future
- * memory allocations by SIP components will be taken from the same pool factory.
- *
- * @param pf	Pool factory that will be used for the lifetime of endpoint.
- *
- * @return the endpoint instance on success.
- */
-PJ_DECL(pjsip_endpoint*) pjsip_endpt_create(pj_pool_factory *pf);
+ * The pool factory reference then will be kept by the endpoint, so that 
+ * future memory allocations by SIP components will be taken from the same
+ * pool factory.
+ *
+ * @param pf	        Pool factory that will be used for the lifetime of 
+ *                      endpoint.
+ * @param name          Optional name to be specified for the endpoint.
+ *                      If this parameter is NULL, then the name will use
+ *                      local host name.
+ * @param endpt         Pointer to receive endpoint instance.
+ *
+ * @return              PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_create(pj_pool_factory *pf,
+                                        pjsip_endpoint **endpt);
 
 /**
@@ -67,4 +75,14 @@
  */
 PJ_DECL(void) pjsip_endpt_destroy(pjsip_endpoint *endpt);
+
+/**
+ * Get endpoint name.
+ *
+ * @param endpt         The SIP endpoint instance.
+ *
+ * @return              Endpoint name, as was registered during endpoint
+ *                      creation. The string is NULL terminated.
+ */
+PJ_DECL(const pj_str_t*) pjsip_endpt_name(const pjsip_endpoint *endpt);
 
 /**
@@ -155,7 +173,10 @@
  *
  * @param endpt	    The SIP endpoint.
- * @return	    The new transaction, or NULL on failure.
- */
-PJ_DECL(pjsip_transaction*) pjsip_endpt_create_tsx(pjsip_endpoint *endpt);
+ * @param p_tsx	    Pointer to receive the transaction.
+ *
+ * @return	    PJ_SUCCESS or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_create_tsx(pjsip_endpoint *endpt,
+					    pjsip_transaction **p_tsx);
 
 /**
@@ -188,8 +209,11 @@
  * This function, like all other endpoint functions, is thread safe.
  *
- * @param endpt the endpoint.
- * @return new transmit data.
- */
-PJ_DECL(pjsip_tx_data*) pjsip_endpt_create_tdata( pjsip_endpoint *endpt );
+ * @param endpt	    The endpoint.
+ * @param p_tdata    Pointer to receive transmit data buffer.
+ *
+ * @return	    PJ_SUCCESS or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_create_tdata( pjsip_endpoint *endpt,
+					       pjsip_tx_data **p_tdata);
 
 /**
@@ -333,4 +357,22 @@
 
 /**
+ * Log an error.
+ */
+PJ_DECL(void) pjsip_endpt_log_error( pjsip_endpoint *endpt,
+				     const char *sender,
+                                     pj_status_t error_code,
+                                     const char *format,
+                                     ... );
+
+#define PJSIP_ENDPT_LOG_ERROR(expr)   \
+            pjsip_endpt_log_error expr
+
+#define PJSIP_ENDPT_TRACE(tracing,expr) \
+            do {                        \
+                if ((tracing))          \
+                    PJ_LOG(4,expr);     \
+            } while (0)
+
+/**
  * @}
  */
Index: /pjproject/main/pjsip/include/pjsip/sip_errno.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_errno.h	(revision 43)
+++ /pjproject/main/pjsip/include/pjsip/sip_errno.h	(revision 43)
@@ -0,0 +1,86 @@
+/* $Id$ 
+ */
+#ifndef __PJSIP_SIP_ERRNO_H__
+#define __PJSIP_SIP_ERRNO_H__
+
+#include <pj/errno.h>
+
+/**
+ * Start of error code relative to PJ_ERRNO_START_USER.
+ */
+#define PJSIP_ERRNO_START       (PJ_ERRNO_START_USER+10000)
+
+/**
+ * Create error value from SIP status code.
+ * @param code      SIP status code.
+ * @return          Error code in pj_status_t namespace.
+ */
+#define PJSIP_ERRNO_FROM_SIP_STATUS(code)   (PJSIP_ERRNO_START+code)
+
+/**
+ * Get SIP status code from error value.
+ * If conversion to SIP status code is not available, a SIP status code
+ * 599 will be returned.
+ *
+ * @param status    Error code in pj_status_t namespace.
+ * @return          SIP status code.
+ */
+#define PJSIP_ERRNO_TO_SIP_STATUS(status)               \
+         ((status>=PJSIP_ERRNO_FROM_SIP_STATUS(100) &&  \
+           status<PJSIP_ERRNO_FROM_SIP_STATUS(999)) ?   \
+          status-PJSIP_ERRNO_FROM_SIP_STATUS(0) : 599)
+
+
+/**
+ * Start of PJSIP generated error code values.
+ */
+#define PJSIP_ERRNO_START_PJSIP (PJSIP_ERRNO_START + 10000)
+
+/**
+ * @hideinitializer
+ * Missing required header(s).
+ */
+#define PJSIP_EMISSINGHDR       (PJSIP_ERRNO_START_PJSIP + 1)
+/**
+ * @hideinitializer
+ * Unsupported URL scheme.
+ */
+#define PJSIP_EINVALIDSCHEME    (PJSIP_ERRNO_START_PJSIP + 2)
+/**
+ * @hideinitializer
+ * Transaction has just been destroyed.
+ */
+#define PJSIP_ETSXDESTROYED     (PJSIP_ERRNO_START_PJSIP + 3)
+/**
+ * @hideinitializer
+ * Buffer overflow. See also PJSIP_EMSGTOOLONG.
+ */
+#define PJSIP_EOVERFLOW         (PJSIP_ERRNO_START_PJSIP + 4)
+/**
+ * @hideinitializer
+ * Message not completely received.
+ */
+#define PJSIP_EPARTIALMSG       (PJSIP_ERRNO_START_PJSIP + 5)
+/**
+ * @hideinitializer
+ * Message too long. See also PJSIP_EOVERFLOW.
+ */
+#define PJSIP_EMSGTOOLONG	(PJSIP_ERRNO_START_PJSIP + 6)
+/**
+ * @hideinitializer
+ * Buffer is being sent, operation still pending.
+ */
+#define PJSIP_EPENDINGTX	(PJSIP_ERRNO_START_PJSIP + 7)
+/**
+ * @hideinitializer
+ * Unsupported transport type.
+ */
+#define PJSIP_EUNSUPTRANSPORT	(PJSIP_ERRNO_START_PJSIP + 8)
+/**
+ * @hideinitializer
+ * Invalid Via header in response (sent-by, etc).
+ */
+#define PJSIP_EINVALIDVIA	(PJSIP_ERRNO_START_PJSIP + 9)
+
+
+#endif	/* __PJSIP_SIP_ERRNO_H__ */
Index: /pjproject/main/pjsip/include/pjsip/sip_event.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_event.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_event.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_EVENT_H__
@@ -26,5 +25,5 @@
 {
     /** Unidentified event. */
-    PJSIP_EVENT_UNIDENTIFIED,
+    PJSIP_EVENT_UNKNOWN,
 
     /** Timer event, normally only used internally in transaction. */
@@ -41,8 +40,8 @@
 
     /** Transaction state changed event. */
-    PJSIP_EVENT_TSX_STATE_CHANGED,
+    PJSIP_EVENT_TSX_STATE,
 
     /** 2xx response received event. */
-    PJSIP_EVENT_RX_200_RESPONSE,
+    PJSIP_EVENT_RX_200_MSG,
 
     /** ACK request received event. */
@@ -56,5 +55,5 @@
 
     /** On before transmitting message. */
-    PJSIP_EVENT_BEFORE_TX,
+    PJSIP_EVENT_PRE_TX_MSG,
 
 } pjsip_event_id_e;
@@ -77,44 +76,206 @@
 {
     /** This is necessary so that we can put events as a list. */
-    PJ_DECL_LIST_MEMBER(struct pjsip_event)
+    PJ_DECL_LIST_MEMBER(struct pjsip_event);
 
     /** The event type, can be any value of \b pjsip_event_id_e.
-     *  @see pjsip_event_id_e
      */
     pjsip_event_id_e type;
 
-    /** This field determines what is the content of \b src (source data). 
-     */
-    pjsip_event_id_e src_type;
-
-    /** Source data, which content is dependent on \b src_type.
-     *  - if src_type==PJSIP_EVENT_RX_MSG, src.rdata is valid.
-     *  - if src_type==PJSIP_EVENT_TX_MSG, src.tdata is valid.
-     *  - if src_type==PJSIP_EVENT_TIMER, src.timer is valid.
+    /*
+     * The event body.
+     * By convention, the first member of each struct in the union must be
+     * the pointer which is relevant to the event.
      */
     union
     {
-	pjsip_rx_data	*rdata;
-	pjsip_tx_data	*tdata;
-	pj_timer_entry	*timer;
-	void		*data;
-	unsigned long	 udata;
-    } src;
-
-    /** The object that generates this event. */
-    union
-    {
-	pjsip_transaction  *tsx;
-	void		   *ptr;
-	unsigned long	    udata;
-    } obj;
-
-    /** Other data. */
-    union
-    {
-	long		    long_data;
-	void *		    ptr_data;
-    } data;
+        /** Timer event. */
+        struct
+        {
+            pj_timer_entry *entry;      /**< The timer entry.           */
+        } timer;
+
+        /** Transaction state has changed event. */
+        struct
+        {
+            union
+            {
+                pjsip_rx_data   *rdata; /**< The incoming message.      */
+                pjsip_tx_data   *tdata; /**< The outgoing message.      */
+                pj_timer_entry  *timer; /**< The timer.                 */
+                pj_status_t      status;/**< Transport error status.    */
+                void            *data;  /**< Generic data.              */
+            } src;
+            pjsip_transaction   *tsx;   /**< The transaction.           */
+            pjsip_event_id_e    type;   /**< Type of event source:      
+                                         *      - PJSIP_EVENT_TX_MSG
+                                         *      - PJSIP_EVENT_RX_MSG,
+                                         *      - PJSIP_EVENT_TRANSPORT_ERROR
+                                         *      - PJSIP_EVENT_TIMER
+                                         *      - PJSIP_EVENT_USER
+                                         */
+        } tsx_state;
+
+        /** Message transmission event. */
+        struct
+        {
+            pjsip_tx_data       *tdata; /**< The transmit data buffer.  */
+            pjsip_transaction   *tsx;   /**< The transaction.           */
+
+        } tx_msg;
+
+        /** Pre-transmission event. */
+        struct
+        {
+            pjsip_tx_data       *tdata; /**< Msg to be transmitted.     */
+            pjsip_transaction   *tsx;   /**< The transaction.           */
+            int                  retcnt;/**< Retransmission count.      */
+        } pre_tx_msg;
+
+        /** Transmission error event. */
+        struct
+        {
+            pjsip_tx_data       *tdata; /**< The transmit data.         */
+            pjsip_transaction   *tsx;   /**< The transaction.           */
+        } tx_error;
+
+        /** Message arrival event. */
+        struct
+        {
+            pjsip_rx_data       *rdata; /**< The receive data buffer.   */
+            pjsip_transaction   *tsx;   /**< The transaction.           */
+        } rx_msg;
+
+        /** Receipt of 200/INVITE response. */
+        struct
+        {
+            pjsip_rx_data       *rdata; /**< The 200 response msg.      */
+        } rx_200_msg;
+
+        /** Receipt of ACK message. */
+        struct
+        {
+            pjsip_rx_data       *rdata; /**< The ack message.           */
+        } rx_ack_msg;
+
+        /** Notification that endpoint has discarded a message. */
+        struct
+        {
+            pjsip_rx_data       *rdata; /**< The discarded message.     */
+            pj_status_t          reason;/**< The reason.                */
+        } discard_msg;
+
+        /** User event. */
+        struct
+        {
+            void                *user1; /**< User data 1.               */
+            void                *user2; /**< User data 2.               */
+            void                *user3; /**< User data 3.               */
+            void                *user4; /**< User data 4.               */
+        } user;
+
+    } body;
 };
+
+/**
+ * Init timer event.
+ */
+#define PJSIP_EVENT_INIT_TIMER(event,pentry)            \
+        do { \
+            (event).type = PJSIP_EVENT_TIMER;           \
+            (event).body.timer.entry = pentry;          \
+        } while (0)
+
+/**
+ * Init tsx state event.
+ */
+#define PJSIP_EVENT_INIT_TSX_STATE(event,ptsx,ptype,pdata)   \
+        do { \
+            (event).type = PJSIP_EVENT_TSX_STATE;           \
+            (event).body.tsx_state.tsx = ptsx;		    \
+            (event).body.tsx_state.type = ptype;            \
+            (event).body.tsx_state.src.data = pdata;        \
+        } while (0)
+
+/**
+ * Init tx msg event.
+ */
+#define PJSIP_EVENT_INIT_TX_MSG(event,ptsx,ptdata)	\
+        do { \
+            (event).type = PJSIP_EVENT_TX_MSG;          \
+            (event).body.tx_msg.tsx = ptsx;		\
+            (event).body.tx_msg.tdata = ptdata;		\
+        } while (0)
+
+/**
+ * Init rx msg event.
+ */
+#define PJSIP_EVENT_INIT_RX_MSG(event,ptsx,prdata)	\
+        do { \
+            (event).type = PJSIP_EVENT_RX_MSG;		\
+            (event).body.rx_msg.tsx = ptsx;		\
+            (event).body.rx_msg.rdata = prdata;		\
+        } while (0)
+
+/**
+ * Init transport error event.
+ */
+#define PJSIP_EVENT_INIT_TRANSPORT_ERROR(event,ptsx,ptdata)   \
+        do { \
+            (event).type = PJSIP_EVENT_TRANSPORT_ERROR; \
+            (event).body.tx_error.tsx = ptsx;		\
+            (event).body.tx_error.tdata = ptdata;	\
+        } while (0)
+
+/**
+ * Init rx 200/INVITE event.
+ */
+#define PJSIP_EVENT_INIT_RX_200_MSG(event,prdata)       \
+        do { \
+            (event).type = PJSIP_EVENT_RX_200_MSG;      \
+            (event).body.rx_200_msg.rdata = prdata;	\
+        } while (0)
+
+/**
+ * Init rx ack msg event.
+ */
+#define PJSIP_EVENT_INIT_RX_ACK_MSG(event,prdata)       \
+        do { \
+            (event).type = PJSIP_EVENT_RX_ACK_MSG;      \
+            (event).body.rx_ack_msg.rdata = prdata;	\
+        } while (0)
+
+/**
+ * Init discard msg event.
+ */
+#define PJSIP_EVENT_INIT_DISCARD_MSG(event,prdata,preason)  \
+        do { \
+            (event).type = PJSIP_EVENT_DISCARD_MSG;         \
+            (event).body.discard_msg.rdata = prdata;	    \
+            (event).body.discard_msg.reason = preason;	    \
+        } while (0)
+
+/**
+ * Init user event.
+ */
+#define PJSIP_EVENT_INIT_USER(event,u1,u2,u3,u4)    \
+        do { \
+            (event).type = PJSIP_EVENT_USER;        \
+            (event).body.user.user1 = (void*)u1;     \
+            (event).body.user.user2 = (void*)u2;     \
+            (event).body.user.user3 = (void*)u3;     \
+            (event).body.user.user4 = (void*)u4;     \
+        } while (0)
+
+/**
+ * Init pre tx msg event.
+ */
+#define PJSIP_EVENT_INIT_PRE_TX_MSG(event,ptsx,ptdata,pretcnt) \
+        do { \
+            (event).type = PJSIP_EVENT_PRE_TX_MSG;	\
+            (event).body.pre_tx_msg.tsx = ptsx;		\
+            (event).body.pre_tx_msg.tdata = ptdata;	\
+            (event).body.pre_tx_msg.retcnt = pretcnt;	\
+        } while (0)
+
 
 /**
Index: /pjproject/main/pjsip/include/pjsip/sip_misc.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_misc.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_misc.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_MISC_H__
@@ -31,16 +30,18 @@
  * @param cseq	    Optional CSeq (put -1 to generate random CSeq).
  * @param text	    Optional text body (put NULL to omit body).
+ * @param p_tdata   Pointer to receive the transmit data.
  *
- * @return	    The transmit data.
+ * @return	    PJ_SUCCESS, or the appropriate error code.
  */
-PJ_DECL(pjsip_tx_data*) pjsip_endpt_create_request( pjsip_endpoint *endpt, 
-						    const pjsip_method *method,
-						    const pj_str_t *target,
-						    const pj_str_t *from,
-						    const pj_str_t *to, 
-						    const pj_str_t *contact,
-						    const pj_str_t *call_id,
-						    int cseq, 
-						    const pj_str_t *text);
+PJ_DECL(pj_status_t) pjsip_endpt_create_request( pjsip_endpoint *endpt, 
+						 const pjsip_method *method,
+						 const pj_str_t *target,
+						 const pj_str_t *from,
+						 const pj_str_t *to, 
+						 const pj_str_t *contact,
+						 const pj_str_t *call_id,
+						 int cseq, 
+						 const pj_str_t *text,
+						 pjsip_tx_data **p_tdata);
 
 /**
@@ -59,8 +60,9 @@
  * @param cseq	    Optional CSeq (put -1 to generate random CSeq).
  * @param text	    Optional text body (put NULL to omit body).
+ * @param p_tdata   Pointer to receive the transmit data.
  *
- * @return	    The transmit data.
+ * @return	    PJ_SUCCESS, or the appropriate error code.
  */
-PJ_DECL(pjsip_tx_data*)
+PJ_DECL(pj_status_t)
 pjsip_endpt_create_request_from_hdr( pjsip_endpoint *endpt,
 				     const pjsip_method *method,
@@ -71,5 +73,6 @@
 				     const pjsip_cid_hdr *call_id,
 				     int cseq,
-				     const pj_str_t *text );
+				     const pj_str_t *text,
+				     pjsip_tx_data **p_tdata);
 
 /**
@@ -90,5 +93,5 @@
  *		    the completion of the transaction.
  *
- * @return	    Zero if transaction is started successfully.
+ * @return	    PJ_SUCCESS, or the appropriate error code.
  */
 PJ_DECL(pj_status_t) pjsip_endpt_send_request( pjsip_endpoint *endpt,
@@ -108,10 +111,12 @@
  * @param rdata	    The request receive data.
  * @param code	    Status code to be put in the response.
+ * @param p_tdata   Pointer to receive the transmit data.
  *
- * @return	    Transmit data.
+ * @return	    PJ_SUCCESS, or the appropriate error code.
  */
-PJ_DECL(pjsip_tx_data*) pjsip_endpt_create_response(pjsip_endpoint *endpt,
-						    const pjsip_rx_data *rdata,
-						    int code);
+PJ_DECL(pj_status_t) pjsip_endpt_create_response( pjsip_endpoint *endpt,
+						  const pjsip_rx_data *rdata,
+						  int code,
+						  pjsip_tx_data **p_tdata);
 
 /**
@@ -137,9 +142,11 @@
  * @param endpt	    The endpoint.
  * @param tdata	    The transmit buffer for the request being cancelled.
+ * @param p_tdata   Pointer to receive the transmit data.
  *
- * @return	    Cancel request.
+ * @return	    PJ_SUCCESS, or the appropriate error code.
  */
-PJ_DECL(pjsip_tx_data*) pjsip_endpt_create_cancel( pjsip_endpoint *endpt,
-						   pjsip_tx_data *tdata );
+PJ_DECL(pj_status_t) pjsip_endpt_create_cancel( pjsip_endpoint *endpt,
+						pjsip_tx_data *tdata,
+						pjsip_tx_data **p_tdata);
 
 
@@ -160,5 +167,4 @@
 					     pjsip_host_port *addr);
 
-
 /**
  * @}
Index: /pjproject/main/pjsip/include/pjsip/sip_module.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_module.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_module.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_MODULE_H__
